// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.Consoles.impl.WASAdminConsole");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.ConsoleAbstractClass");
dojo.require("com.ibm.bpm.QuickStart.Helpers.WCCMHelper");

dojo.declare("com.ibm.bpm.QuickStart.Consoles.impl.WASAdminConsole",
    [ com.ibm.bpm.QuickStart.Consoles.impl.ConsoleAbstractClass ], {
    
    dmgrProfileName:null,
    clazz:"WASAdminConsole",
    logger:null,
    constructor: function(name,profileName){
        // top.logError("in wasconsole const");
        this.logger=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getStaticLogger();
    	this.setDmgrProfileName(profileName);
    },
    
    getDmgrProfileName: function(){
        return this.dmgrProfileName;
    },
    setDmgrProfileName: function(dmgrProfileName){
        if(this.dmgrProfileName==null){
            this.dmgrProfileName=dmgrProfileName;
        }
    },
    
    getHostName : function(){
       var method = "getHostName";
       this.logger.entering(this.clazz,method,"getHostName"); 
        
        if(this.getDmgrProfileName()==null){
            return null;
        }
        var ServerIndexServerEntriesByServerName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndexServerEntries(this.getDmgrProfileName(),
        com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDmgrNodeName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName(),com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getCellType(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName())), 
        com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDmgrServerName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName(),com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getCellType(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName()))); 
        if(ServerIndexServerEntriesByServerName==null){
            return null;
        } 
	
        this.logger.exiting(this.clazz,method,"End of getHostName");
        return com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getHostName(ServerIndexServerEntriesByServerName);
    },

    getPort : function(){
       var method = "name";
       this.logger.entering(this.clazz,method,"getPort"); 

        if(this.getDmgrProfileName()==null){
            return null;
        }
        var ServerIndexServerEntriesByServerName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndexServerEntries(this.getDmgrProfileName(),
        com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDmgrNodeName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName(),com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getCellType(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName())), 
        com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDmgrServerName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName(),com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getCellType(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName()))); 
        if(ServerIndexServerEntriesByServerName==null){
            return null;
        } 

       this.logger.exiting(this.clazz,method,"End of getPort");
        return com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getAdminConsolePort(ServerIndexServerEntriesByServerName);
    },
    getUrl : function(){
        return this.inherited(arguments)+"/ibm/console";
    }
    
});
