// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.Helpers.WCCMHelper");
dojo.require("com.ibm.bpm.QuickStart.Helpers.AjaxHelper");
dojo.require("com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper");


com.ibm.bpm.QuickStart.Helpers.WCCMHelper.doesDeploymentEnvironmentExists= function(deName,BPMHome,profileName){
    var DeploymentEnvironments = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentEnvironments(BPMHome,profileName);

    if(DeploymentEnvironments==null){
        return false;
    }
   
    for(var i=0; i<DeploymentEnvironments.length; i++){
        if(DeploymentEnvironments[i].attributes[1].value==deName){
            return true;
        }
    }
    return false;
};
com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndexServerEntries = function(profileName,nodeName,serverName) {

    var ServerIndex = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndex(nodeName,profileName);
    if(ServerIndex == null ){
        return null;
    }
    var ServerIndexServerEntries = ServerIndex.getElementsByTagName("serverEntries");
    for(var i=0;i<ServerIndexServerEntries.length;i++){
        if(ServerIndexServerEntries[i].attributes[1].value==serverName){
        return ServerIndexServerEntries[i];
        }
    }
    return null;
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerType = function(ServerIndexServerEntry){
    if(ServerIndexServerEntry==null){
        return null;
    }
    for( var i =0;i<ServerIndexServerEntry.attributes.length;i++){
        if(ServerIndexServerEntry.attributes[i].name=="serverType"){
            return ServerIndexServerEntry.attributes[i].value;
        }
    }
    return null;
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndex = function(nodeName,profileName){

    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),profileName);
    if(firstAvailableCellName==null){
        return null;
    }

    var ServerIndex = com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getFile(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome()
    +"profiles/"+profileName+"/config/cells/"+firstAvailableCellName+"/nodes/"+nodeName+"/serverindex.xml");
    
    return (ServerIndex!=null ? ServerIndex : null ); 
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getAdminConsolePort = function(ServerIndexServerEntriesByServerName){
        if(ServerIndexServerEntriesByServerName==null){
        return null;
        }
        
        var SpecialEndpoints = ServerIndexServerEntriesByServerName.getElementsByTagName("specialEndpoints");
        for(var i=0;i<SpecialEndpoints.length;i++){
            if(SpecialEndpoints[i].attributes[1].value=="WC_adminhost"){
            return SpecialEndpoints[i].getElementsByTagName("endPoint")[0].attributes[2].value;
            }
        }
        return null;   
};
com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getHostName = function(ServerIndexServerEntriesByServerName){
        if(ServerIndexServerEntriesByServerName==null){
        return null;
        }

    var SpecialEndpoints = ServerIndexServerEntriesByServerName.getElementsByTagName("specialEndpoints");
    for(var i=0;i<SpecialEndpoints.length;i++){
        if(SpecialEndpoints[i].attributes[1].value=="BOOTSTRAP_ADDRESS"){
            return SpecialEndpoints[i].getElementsByTagName("endPoint")[0].attributes[1].value;
        }
    }
    return null;   
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getPort = function(ServerIndexServerEntriesByServerName){
        if(ServerIndexServerEntriesByServerName==null){
        return null;
        }
        
        var SpecialEndpoints = ServerIndexServerEntriesByServerName.getElementsByTagName("specialEndpoints");
        for(var i=0;i<SpecialEndpoints.length;i++){
            if(SpecialEndpoints[i].attributes[1].value=="WC_defaulthost"){
            return SpecialEndpoints[i].getElementsByTagName("endPoint")[0].attributes[2].value;
            }
        }
        return null;   
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentTargetType = function(deploymentTarget){
    return deploymentTarget.attributes[0].value;
};


com.ibm.bpm.QuickStart.Helpers.WCCMHelper.isProcessCenterCluster = function(BPMClusterConfigExtension){
   if(BPMClusterConfigExtension==null){
        return false; 
   }

   var bpdServer = BPMClusterConfigExtension.getElementsByTagName("bpdServer");
   
   if(bpdServer.length==0){
        return false;
   } else {
         // top.logError("ProcessCenter");
        for( var i =0;i<bpdServer[0].attributes.length;i++){
            if(bpdServer[0].attributes[i].value.search("BPMProcessCenter") !=-1){
                return true;
            }
        }
        return false;
   }
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.isProcessServerCluster = function(BPMClusterConfigExtension){
   if(BPMClusterConfigExtension==null){
        return false; 
   }

   var bpdServer = BPMClusterConfigExtension.getElementsByTagName("bpdServer");
   
   if(bpdServer.length==0){
        return false;
   } else {
        for( var i =0;i<bpdServer[0].attributes.length;i++){
            if(bpdServer[0].attributes[i].value.search("BPMProcessServer") !=-1){
                return true;
            }
        }
        return false;
   }
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.isPerformanceDataWarehouseCluster = function(BPMClusterConfigExtension){
   if(BPMClusterConfigExtension==null){
        return false; 
   }
   var performanceDataWarehouse = BPMClusterConfigExtension.getElementsByTagName("performanceDataWarehouse");
   if(performanceDataWarehouse.length==0){
        return false;
   } else {
        for( var i =0;i<performanceDataWarehouse[0].attributes.length;i++){
            if(performanceDataWarehouse[0].attributes[i].value.search("BPMPerformanceDataWarehouse") !=-1){
                return true;
            }
        } 
        return false;
   }
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getBPMClusterType = function(BPMClusterConfigExtension){
    var clusterType = null ;
    if(com.ibm.bpm.QuickStart.Helpers.WCCMHelper.isPerformanceDataWarehouseCluster(BPMClusterConfigExtension)){
        clusterType = "Support";
    } else if (com.ibm.bpm.QuickStart.Helpers.WCCMHelper.isProcessServerCluster(BPMClusterConfigExtension)){
        clusterType = "ProcessServer";
    } else if (com.ibm.bpm.QuickStart.Helpers.WCCMHelper.isProcessCenterCluster(BPMClusterConfigExtension)){
        clusterType = "ProcessCenter";
    }
    return clusterType;
};


com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getBPMClusterConfigExtension = function(clusterName,profileName){
    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),profileName);
    if(firstAvailableCellName==null){
        return null;
    }
    // top.logError(clusterName);
   var BPMClusterConfigExtension = com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getFile(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome()
    +"profiles/"+profileName+"/config/cells/"+firstAvailableCellName+"/clusters/"+clusterName+"/cluster-bpm.xml");

   if(BPMClusterConfigExtension==null){
       return null;
   }
    return BPMClusterConfigExtension;
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getClusterMembersInfo = function(clusterName,profileName){

    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),profileName);
    if(firstAvailableCellName==null){
        return null;
    }

   var ServerCluster = com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getFile(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome()
    +"profiles/"+profileName+"/config/cells/"+firstAvailableCellName+"/clusters/"+clusterName+"/cluster.xml");

   if(ServerCluster==null){
       return null;
   }
   var ClusterMembers = ServerCluster.getElementsByTagName("members");
   return (ClusterMembers!=null? ClusterMembers: null);
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentEnvironments = function(BPMHome,profileName){
    var deploymentEnvironments = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getBPMConfiguration(BPMHome,profileName);
    return (deploymentEnvironments!=null ? deploymentEnvironments.getElementsByTagName("deploymentEnvironments") : null );
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getBPMConfiguration = function(BPMHome,dmgrProfileName){
    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(BPMHome,dmgrProfileName);
    if(firstAvailableCellName==null){
        return null;
    }
    var BPMConfiguration = com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getFile(BPMHome +"profiles/"+dmgrProfileName+"/config/cells/"+firstAvailableCellName+"/cell-bpm.xml");
    return (BPMConfiguration!=null ? BPMConfiguration: null );
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getCellType = function(BPMHome,profileName){
    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(BPMHome,profileName);
    if(firstAvailableCellName==null){
        return null;
    }
    var Cell = com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getFile(BPMHome +"profiles/"+profileName+"/config/cells/"+firstAvailableCellName+"/cell.xml");
    if(Cell==null){
        return null;
    }
    for(var i=0;i<Cell.getElementsByTagName("topology.cell:Cell")[0].attributes.length;i++){
        if(Cell.getElementsByTagName("topology.cell:Cell")[0].attributes[i].name=="cellType"){
            return Cell.getElementsByTagName("topology.cell:Cell")[0].attributes[i].value;
        }
    }
    return null;
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getProductId = function(BPMHome){
    var BPMProduct = com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getTextFile(BPMHome+ "properties/version/BPM.product");
    return BPMProduct.substring(BPMProduct.indexOf("<id>")+4,BPMProduct.indexOf("</id>"));
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName = function(BPMHome,profileName){
    if (top.firstAvailableCellDir == null || !top.firstAvailableCellDir) {
        var cellSubDirectories = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.listSubDirectories(BPMHome+"profiles/" +profileName+ "/config/cells/");
        if(cellSubDirectories==null){
            return null;
        }
        top.firstAvailableCellDir =cellSubDirectories[0];
     }
     return top.firstAvailableCellDir;
};

com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDmgrNodeName = function(BPMHome,profileName,cellType){
    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(BPMHome,profileName);
    if(firstAvailableCellName==null){
        return null;
    }

    var nodeSubDirectories =com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.listSubDirectories(BPMHome+"profiles/"+profileName+ "/config/cells/"+firstAvailableCellName+"/nodes/");
    if(nodeSubDirectories==null){
        return null;
    }

    if(cellType=="STANDALONE"){
        var ServerIndex =  com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndex(nodeSubDirectories[0],profileName);
          if(ServerIndex == null ){
                return null;
          }
        return nodeSubDirectories[0];
    } else {
        for(var i=0;i<nodeSubDirectories.length;i++){
          var ServerIndex =  com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndex(nodeSubDirectories[i],profileName);
          if(ServerIndex == null ){
                return null;
          }
          
          var ServerIndexServerEntries = ServerIndex.getElementsByTagName("serverEntries");
          for(var j=0;j<ServerIndexServerEntries.length;j++){
            if(com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerType(ServerIndexServerEntries[j])=="DEPLOYMENT_MANAGER"){
                return nodeSubDirectories[i];
            }
          }
        }
        return null;
    }
};
com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDmgrServerName = function(BPMHome,profileName,cellType){
    var firstAvailableCellName = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getFirstAvailableCellName(BPMHome,profileName);
    if(firstAvailableCellName==null){
        return null;
    }

    var nodeSubDirectories =com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.listSubDirectories(BPMHome+"profiles/"+profileName+ "/config/cells/"+firstAvailableCellName+"/nodes/");
    if(nodeSubDirectories==null){
        return null;
    }

    if(cellType=="STANDALONE"){
        var ServerIndex =  com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndex(nodeSubDirectories[0],profileName);
          if(ServerIndex == null ){
                return null;
          }
          
        var ServerIndexServerEntries = ServerIndex.getElementsByTagName("serverEntries");
        for(var j=0;j<ServerIndexServerEntries.length;j++){
            if(com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerType(ServerIndexServerEntries[j])=="APPLICATION_SERVER"){
                return ServerIndexServerEntries[j].attributes[1].value;
            }
        }
        return null;
    } else {
        for(var i=0;i<nodeSubDirectories.length;i++){
          var ServerIndex =  com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerIndex(nodeSubDirectories[i],profileName);
          if(ServerIndex == null ){
                return null;
          }
          
          var ServerIndexServerEntries = ServerIndex.getElementsByTagName("serverEntries");
          for(var j=0;j<ServerIndexServerEntries.length;j++){
            if(com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getServerType(ServerIndexServerEntries[j])=="DEPLOYMENT_MANAGER"){
                return ServerIndexServerEntries[j].attributes[1].value;
            }
          }
        }
        return null;
    }
}; 